Skip to main content

PublicKeyAlgorithm

Enum PublicKeyAlgorithm 

Source
#[non_exhaustive]
pub enum PublicKeyAlgorithm {
Show 22 variants RSAEncryptSign, RSAEncrypt, RSASign, ElGamalEncrypt, DSA, ECDH, ECDSA, ElGamalEncryptSign, EdDSA, X25519, X448, Ed25519, Ed448, MLDSA65_Ed25519, MLDSA87_Ed448, SLHDSA128s, SLHDSA128f, SLHDSA256s, MLKEM768_X25519, MLKEM1024_X448, Private(u8), Unknown(u8),
}
Expand description

The OpenPGP public key algorithms as defined in Section 9.1 of RFC 9580.

§Examples

use sequoia_openpgp as openpgp;
use openpgp::cert::prelude::*;
use openpgp::types::PublicKeyAlgorithm;

let (cert, _) = CertBuilder::new()
    .set_cipher_suite(CipherSuite::Cv25519)
    .generate()?;

assert_eq!(cert.primary_key().key().pk_algo(), PublicKeyAlgorithm::EdDSA);

Variants (Non-exhaustive)§

This enum is marked as non-exhaustive
Non-exhaustive enums could have additional variants added in future. Therefore, when matching against variants of non-exhaustive enums, an extra wildcard arm must be added to account for any future variants.
§

RSAEncryptSign

RSA (Encrypt or Sign)

§

RSAEncrypt

👎Deprecated:

Use PublicKeyAlgorithm::RSAEncryptSign.

RSA Encrypt-Only, deprecated in RFC 4880.

§

RSASign

👎Deprecated:

Use PublicKeyAlgorithm::RSAEncryptSign.

RSA Sign-Only, deprecated in RFC 4880.

§

ElGamalEncrypt

👎Deprecated:

Use a newer public key algorithm instead.

ElGamal (Encrypt-Only), deprecated in RFC 9580.

§

DSA

👎Deprecated:

Use a newer public key algorithm instead.

DSA (Digital Signature Algorithm)

§

ECDH

Elliptic curve DH

§

ECDSA

Elliptic curve DSA

§

ElGamalEncryptSign

👎Deprecated:

Use a newer public key algorithm instead.

ElGamal (Encrypt or Sign), deprecated in RFC 4880.

§

EdDSA

“Twisted” Edwards curve DSA

§

X25519

X25519 (RFC 7748).

§

X448

X448 (RFC 7748).

§

Ed25519

Ed25519 (RFC 8032).

§

Ed448

Ed448 (RFC 8032).

§

MLDSA65_Ed25519

Composite signature algorithm using ML-DSA-65 and Ed25519.

§

MLDSA87_Ed448

Composite signature algorithm using ML-DSA-87 and Ed448.

§

SLHDSA128s

SLH-DSA-SHAKE signature algorithm 128 bit, small signatures.

Note: RFC 9980 only specifies the SHAKE variant of the SLH-DSA algorithm.

§

SLHDSA128f

SLH-DSA-SHAKE signature algorithm 128 bit, fast signatures.

Note: RFC 9980 only specifies the SHAKE variant of the SLH-DSA algorithm.

§

SLHDSA256s

SLH-DSA-SHAKE signature algorithm 256 bit, small signatures.

Note: RFC 9980 only specifies the SHAKE variant of the SLH-DSA algorithm.

§

MLKEM768_X25519

Composite KEM using ML-KEM-768 and X25519.

§

MLKEM1024_X448

Composite KEM using ML-KEM-1024 and X448.

§

Private(u8)

Private algorithm identifier.

§

Unknown(u8)

Unknown algorithm identifier.

Implementations§

Source§

impl PublicKeyAlgorithm

Source

pub fn for_signing(&self) -> bool

Returns true if the algorithm can sign data.

§Examples
use sequoia_openpgp as openpgp;
use openpgp::types::PublicKeyAlgorithm;

assert!(PublicKeyAlgorithm::EdDSA.for_signing());
assert!(PublicKeyAlgorithm::RSAEncryptSign.for_signing());
assert!(!PublicKeyAlgorithm::ElGamalEncrypt.for_signing());
Source

pub fn for_encryption(&self) -> bool

Returns true if the algorithm can encrypt data.

§Examples
use sequoia_openpgp as openpgp;
use openpgp::types::PublicKeyAlgorithm;

assert!(!PublicKeyAlgorithm::EdDSA.for_encryption());
assert!(PublicKeyAlgorithm::RSAEncryptSign.for_encryption());
assert!(PublicKeyAlgorithm::ElGamalEncrypt.for_encryption());
Source

pub fn is_supported(&self) -> bool

Returns whether this algorithm is supported.

§Examples
use sequoia_openpgp as openpgp;
use openpgp::types::PublicKeyAlgorithm;

assert!(PublicKeyAlgorithm::EdDSA.is_supported());
assert!(PublicKeyAlgorithm::RSAEncryptSign.is_supported());
assert!(!PublicKeyAlgorithm::Private(101).is_supported());
Source

pub fn variants() -> impl Iterator<Item = PublicKeyAlgorithm>

Returns an iterator over all valid variants.

Returns an iterator over all known variants. This does not include the PublicKeyAlgorithm::Private, or PublicKeyAlgorithm::Unknown variants.

Trait Implementations§

Source§

impl Clone for PublicKeyAlgorithm

Source§

fn clone(&self) -> PublicKeyAlgorithm

Returns a duplicate of the value. Read more
1.0.0 (const: unstable) · Source§

fn clone_from(&mut self, source: &Self)

Performs copy-assignment from source. Read more
Source§

impl Copy for PublicKeyAlgorithm

Source§

impl Debug for PublicKeyAlgorithm

Source§

fn fmt(&self, f: &mut Formatter<'_>) -> Result<(), Error>

Formats the value using the given formatter. Read more
Source§

impl Display for PublicKeyAlgorithm

Formats the public key algorithm name.

There are two ways the public key algorithm name can be formatted. By default the short name is used. The alternate format uses the full public key algorithm name.

§Examples

use sequoia_openpgp as openpgp;
use openpgp::types::PublicKeyAlgorithm;

// default, short format
assert_eq!("ECDH", format!("{}", PublicKeyAlgorithm::ECDH));

// alternate, long format
assert_eq!("ECDH public key algorithm", format!("{:#}", PublicKeyAlgorithm::ECDH));
Source§

fn fmt(&self, f: &mut Formatter<'_>) -> Result<(), Error>

Formats the value using the given formatter. Read more
Source§

impl Eq for PublicKeyAlgorithm

Source§

impl From<u8> for PublicKeyAlgorithm

Source§

fn from(u: u8) -> PublicKeyAlgorithm

Converts to this type from the input type.
Source§

impl Hash for PublicKeyAlgorithm

Source§

fn hash<__H>(&self, state: &mut __H)
where __H: Hasher,

Feeds this value into the given Hasher. Read more
1.3.0 · Source§

fn hash_slice<H>(data: &[Self], state: &mut H)
where H: Hasher, Self: Sized,

Feeds a slice of this type into the given Hasher. Read more
Source§

impl Ord for PublicKeyAlgorithm

Source§

fn cmp(&self, other: &PublicKeyAlgorithm) -> Ordering

This method returns an Ordering between self and other. Read more
1.21.0 (const: unstable) · Source§

fn max(self, other: Self) -> Self
where Self: Sized,

Compares and returns the maximum of two values. Read more
1.21.0 (const: unstable) · Source§

fn min(self, other: Self) -> Self
where Self: Sized,

Compares and returns the minimum of two values. Read more
1.50.0 (const: unstable) · Source§

fn clamp(self, min: Self, max: Self) -> Self
where Self: Sized,

Restrict a value to a certain interval. Read more
Source§

fn clamp_to<R>(self, range: R) -> Self
where Self: Sized, R: ClampBounds<Self>,

🔬This is a nightly-only experimental API. (clamp_to)
Restrict a value to a certain range. Read more
Source§

impl PartialEq for PublicKeyAlgorithm

Source§

fn eq(&self, other: &PublicKeyAlgorithm) -> bool

Equality operator ==. Read more
1.0.0 (const: unstable) · Source§

fn ne(&self, other: &Rhs) -> bool

Inequality operator !=. Read more
Source§

impl PartialOrd for PublicKeyAlgorithm

Source§

fn partial_cmp(&self, other: &PublicKeyAlgorithm) -> Option<Ordering>

This method returns an ordering between self and other values if one exists. Read more
1.0.0 (const: unstable) · Source§

fn lt(&self, other: &Rhs) -> bool

Tests less than (for self and other) and is used by the < operator. Read more
1.0.0 (const: unstable) · Source§

fn le(&self, other: &Rhs) -> bool

Tests less than or equal to (for self and other) and is used by the <= operator. Read more
1.0.0 (const: unstable) · Source§

fn gt(&self, other: &Rhs) -> bool

Tests greater than (for self and other) and is used by the > operator. Read more
1.0.0 (const: unstable) · Source§

fn ge(&self, other: &Rhs) -> bool

Tests greater than or equal to (for self and other) and is used by the >= operator. Read more
Source§

impl StructuralPartialEq for PublicKeyAlgorithm

Auto Trait Implementations§

Blanket Implementations§

Source§

impl<T> Any for T
where T: 'static + ?Sized,

Source§

fn type_id(&self) -> TypeId

Gets the TypeId of self. Read more
Source§

impl<T> Borrow<T> for T
where T: ?Sized,

Source§

fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
Source§

impl<T> BorrowMut<T> for T
where T: ?Sized,

Source§

fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
Source§

impl<T> CloneToUninit for T
where T: Clone,

Source§

unsafe fn clone_to_uninit(&self, dest: *mut u8)

🔬This is a nightly-only experimental API. (clone_to_uninit)
Performs copy-assignment from self to dest. Read more
Source§

impl<Q, K> Comparable<K> for Q
where Q: Ord + ?Sized, K: Borrow<Q> + ?Sized,

Source§

fn compare(&self, key: &K) -> Ordering

Compare self to key and return their ordering.
Source§

impl<T> DynClone for T
where T: Clone,

Source§

fn __clone_box(&self, _: Private) -> *mut ()

Source§

impl<Q, K> Equivalent<K> for Q
where Q: Eq + ?Sized, K: Borrow<Q> + ?Sized,

Source§

fn equivalent(&self, key: &K) -> bool

Compare self to key and return true if they are equal.
Source§

impl<T> From<T> for T

Source§

fn from(t: T) -> T

Returns the argument unchanged.

Source§

impl<T> Instrument for T

Source§

fn instrument(self, span: Span) -> Instrumented<Self> ⓘ

Instruments this type with the provided Span, returning an Instrumented wrapper. Read more
Source§

fn in_current_span(self) -> Instrumented<Self> ⓘ

Instruments this type with the current Span, returning an Instrumented wrapper. Read more
Source§

impl<T, U> Into<U> for T
where U: From<T>,

Source§

fn into(self) -> U

Calls U::from(self).

That is, this conversion is whatever the implementation of From<T> for U chooses to do.

Source§

impl<T> IntoEither for T

Source§

fn into_either(self, into_left: bool) -> Either<Self, Self> ⓘ

Converts self into a Left variant of Either<Self, Self> if into_left is true. Converts self into a Right variant of Either<Self, Self> otherwise. Read more
Source§

fn into_either_with<F>(self, into_left: F) -> Either<Self, Self> ⓘ
where F: FnOnce(&Self) -> bool,

Converts self into a Left variant of Either<Self, Self> if into_left(&self) returns true. Converts self into a Right variant of Either<Self, Self> otherwise. Read more
Source§

impl<T> MaybeSend for T

Source§

impl<T> MaybeSync for T

Source§

impl<T> Package for T
where T: Clone + Eq + Hash + Debug + Display,

Source§

impl<T> Pointable for T

Source§

const ALIGN: usize

The alignment of pointer.
Source§

type Init = T

The type for initializers.
Source§

unsafe fn init(init: <T as Pointable>::Init) -> usize

Initializes a with the given initializer. Read more
Source§

unsafe fn deref<'a>(ptr: usize) -> &'a T

Dereferences the given pointer. Read more
Source§

unsafe fn deref_mut<'a>(ptr: usize) -> &'a mut T

Mutably dereferences the given pointer. Read more
Source§

unsafe fn drop(ptr: usize)

Drops the object pointed to by the given pointer. Read more
Source§

impl<T> PolicyExt for T
where T: ?Sized,

Source§

fn and<P, B, E>(self, other: P) -> And<T, P>
where T: Sized + Policy<B, E>, P: Policy<B, E>,

Create a new Policy that returns Action::Follow only if self and other return Action::Follow. Read more
Source§

fn or<P, B, E>(self, other: P) -> Or<T, P>
where T: Sized + Policy<B, E>, P: Policy<B, E>,

Create a new Policy that returns Action::Follow if either self or other returns Action::Follow. Read more
Source§

impl<T> Same for T

Source§

type Output = T

Should always be Self
Source§

impl<T> ToCompactString for T
where T: Display,

Source§

impl<T> ToLine for T
where T: Display,

Source§

fn to_line(&self) -> Line<'_>

Converts the value to a Line.
Source§

impl<T> ToOwned for T
where T: Clone,

Source§

type Owned = T

The resulting type after obtaining ownership.
Source§

fn to_owned(&self) -> T

Creates owned data from borrowed data, usually by cloning. Read more
Source§

fn clone_into(&self, target: &mut T)

Uses borrowed data to replace owned data, usually by cloning. Read more
Source§

impl<T> ToSpan for T
where T: Display,

Source§

fn to_span(&self) -> Span<'_>

Converts the value to a Span.
Source§

impl<T> ToString for T
where T: Display + ?Sized,

Source§

fn to_string(&self) -> String

Converts the given value to a String. Read more
Source§

impl<T> ToText for T
where T: Display,

Source§

fn to_text(&self) -> Text<'_>

Converts the value to a Text.
Source§

impl<T, U> TryFrom<U> for T
where U: Into<T>,

Source§

type Error = !

The type returned in the event of a conversion error.
Source§

fn try_from(value: U) -> Result<T, !>

Performs the conversion.
Source§

impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

Source§

type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
Source§

fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.
Source§

impl<T> WithSubscriber for T

Source§

fn with_subscriber<S>(self, subscriber: S) -> WithDispatch<Self> ⓘ
where S: Into<Dispatch>,

Attaches the provided Subscriber to this type, returning a WithDispatch wrapper. Read more
Source§

fn with_current_subscriber(self) -> WithDispatch<Self> ⓘ

Attaches the current default Subscriber to this type, returning a WithDispatch wrapper. Read more